/** utilisation-de-la-classe-Date
*    ============= 
* @author Dabancourt 
* @version 0.9  du 20/06/2004 
*/ 

import iut.algo.Date;


public class VecteurDate
{  

	protected Date[] tab;
	protected int taille;
	
	public VecteurDate()
	{
		this.taille = 5 ;	// l'attribut taille a une valeur
		this.tab = new Date[5] ;	// l'attribut tab est initialise
	}
	
	public VecteurDate(int taille)
	{
		this.taille = taille ;	// l'attribut taille a une valeur
		this.tab = new  Date[taille] ;	// l'attribut tab est initialise
	}
	
	public VecteurDate(VecteurDate v)
	{
	 	this(v.taille);
	 	
	 	// les attribut tab et taille sont maintenant initialises
		int i;
	 	for (i=0; i<taille; i++){
	 		this.tab[i] = v.tab[i];
	 	}
	}
	
		
	public void setDateAt(Date nb,int position) 
	{
		this.tab[position] = nb ;
	}
	
	
	
	public Date getDateAt(int position)
	{
		return (this.tab[position]);
	}
	
	public int getTaille()
	{
		return (this.taille);
	}
	
	public void echanger (int pos1, int pos2)
	{
		Date tmp;

		tmp = tab[pos1] ;
		tab[pos1] = tab[pos2] ;
		tab[pos2] = tmp ;
	}
	
	
	/******************************************
	 *    les algorithmes de tri              *
	 ******************************************/
	 
	 public String toString(){
	 	int i;
	 	String res="[ ";
	 	
	 	for (i=0; i<taille; i++){
	 		res = res + " - " + tab[i];
	 		System.out.print("*");
	 	}

	 	return (res+"]");
	 }
	 
	 public void remplirHasard(){
	 	int i;
	 	
	 	for (i=0; i<taille; i++)
	 	{
	 		tab[i] = new Date( (int)(30*Math.random()),(int)(12*Math.random()),1900+(int)(1000*Math.random()) );
	 	}
	 }	
	  
	/**********************************
	 *  recherche Dichotomique		  *
	 **********************************/	 
	public int rechercherDicho(Date x)
	{
		// retourne la position de la valeur cherchee
		int gauche, milieu, droite;
	 	boolean	trouve;
	
		gauche  = 0 ;
		droite = taille - 1 ;
		milieu = (gauche+droite)/2 ; 		// division entiere pour trouver le milieu
		trouve = false ;
		
		while ( (gauche<=droite ) && (trouve==false) )	
		 	// if on ne trouve rien, a un moment on a gauche = droite
		{
			milieu  = (gauche+droite) / 2 ;			// recalcule le milieu (DIV)
			trouve  = ( tab[milieu].estEgale(x) ) ;			// on a trouve l'element ?
			
			if ( x.precede(tab[milieu])==false && x.estEgale(tab[milieu])==false ) 			// l'element est a droite du milieu
			 	gauche = milieu + 1 ;
			else					// else, il est a gauche du milieu
			 	droite = milieu - 1 ;
		}
		if (trouve == true)
		 	return milieu ;				// on sort
		else
		 	return(-1) ; 				// element introuvable : on sort
	}

	public int rechercherDichoRecursif(Date x)
	{
		return (rechercherDichoRecursif (x, 0, taille-1) );
	}


	private int rechercherDichoRecursif(Date x, int gauche, int droite)
	{

		int milieu;

		milieu = (gauche+droite)/2 ; 		// division entiere pour trouver le milieu

		if (tab[milieu].estEgale(x)) 			// deux conditions d'arret
			return (milieu) ;
		if (droite <= gauche ) 
			return (-1) ;

		if ( x.precede(tab[milieu]) )			// appels recursifs
		 	return( rechercherDichoRecursif (x, gauche, milieu-1) ) ;
		else					// sinon, il est a droite du milieu
			return( rechercherDichoRecursif (x, milieu+1, droite) ) ;
	}

	 	 
	/**************************
	 *  le tri selection	  *
	 **************************/
	public void triSelection ()
	{
		int indice, indiceNonTrie, posMinimum;
		// indice, indiceNonTrie et posMinimum sont des indices
		Date minimum;
		// minimum est une valeur

		indice = 0;	// autant d'iteration que d'elements dans le tableau
		while ( indice < taille ) 
		{
			minimum = tab[indice];
			posMinimum = indice;

			// boucle de recherche du minimum
			indiceNonTrie  = indice;
			while (indiceNonTrie < taille)
			{
				if ( tab[indiceNonTrie].precede(minimum)) 
				{
					minimum = tab[indiceNonTrie] ;
					posMinimum  = indiceNonTrie;
				}
				indiceNonTrie = indiceNonTrie + 1 ;
			}
			echanger(posMinimum, indice) ;
			indice = indice + 1 ;
		}
	}

	/**************************
	 *  le tri insertion	  *
	 **************************/
	public void triInsertion ()
	{
		int indice, indiceInserer;
		// indice, indiceNonTrie et posMinimum sont des indices
		Date valeurAInserer;	// valeurAInserer est une valeur

        indice = 1;
        while (indice < taille)
        {
        	valeurAInserer = tab[indice];
			indiceInserer = indice-1;

        	while ( (indiceInserer >= 0)&&(valeurAInserer.precede(tab[indiceInserer]) || valeurAInserer.estEgale(tab[indiceInserer])) ) 
			{
				tab[indiceInserer+1] = tab[indiceInserer] ;
				indiceInserer = indiceInserer - 1 ;
			}
			tab[indiceInserer+1] = valeurAInserer;
			
        	indice = indice + 1;
        }
	}
	
	/**************************
	 *  le tri Bulle		  *
	 **************************/
	public void triBulle ()
	{

		int nbIteration,indice;
	
		boolean pasEncoreTrie;
	
		pasEncoreTrie = true;
		nbIteration = taille - 1 ;
		while ( pasEncoreTrie == true ) 
		{
			indice = 0 ;		// parcours du tableau non trie !!
			pasEncoreTrie = false;	// on suppose que tab est completement trie
			
			while(indice < nbIteration)	// pour faire descendre le + lourd
			{
				if ( tab[indice].precede(tab[indice+1])==false )
				{
					echanger(indice,indice+1) ;		// on echange 
					pasEncoreTrie = true ;			// on a fait un echange : il n'etait pas completement trie
				}
				indice =  indice + 1 ;
			}
			nbIteration = nbIteration - 1;		// on recommence de l'indice 0 a nbIteration-1
		}			// sauf si la variable pasEncoreTrie toujours Vrai : tab completement trie !
	}	
	
	
	
	/**************************
	 *  le tri fusion		  *
	 **************************/
    public void triFusion()
	{
		triFusion(0,taille-1);
	}

    private void triFusion(int debut,int fin)
	{
		int milieu;
		
		if (debut!=fin)
		{
			milieu=(fin+debut)/2;
			
			triFusion(debut,milieu);
			triFusion(milieu+1,fin);
			
			fusion(debut,milieu,fin);
		}
	}

	private void fusion(int debut1,int fin1,int fin2)
	{
		int debut2;
		Date tabTemp[];
		int compt1;
		int compt2;
		int i;
		
		tabTemp = new Date[fin1-debut1+1];
		debut2=fin1+1;
		
		//on recopie les elements du debut du tableau
		for(i=debut1;i<=fin1;i++)
		{
			tabTemp[i-debut1]=tab[i];
		}
		
		compt1=debut1;
		compt2=debut2;
		i = debut1;
		
		while (	 (i<=fin2)&& (compt1!=debut2))
		{
			if (compt2==(fin2+1)) //c'est que tous les elements du second tableau ont ete utilises
			{
				tab[i]=tabTemp[compt1-debut1]; //on ajoute les elements restants du premier tableau
				compt1++;
			}
			else if ( tabTemp[compt1-debut1].precede(tab[compt2]) )
			{
				tab[i]=tabTemp[compt1-debut1]; //on ajoute un element du premier tableau
				compt1++;
			}
			else
			{
				tab[i]=tab[compt2]; //on ajoute un element du second tableau
				compt2++;
			}
			i = i + 1;
		}
	}

	
	/**************************
	 *  le tri rapide		  *
	 **************************/
    private int placePivot(int debut, int fin)
    {
        int indicePivot, indiceGauche, indiceDroite;
        Date valeurPivot;
        boolean pasPlace;
        
        indicePivot = debut;
        valeurPivot = tab[indicePivot];
        
        indiceGauche= debut+1-1;
        indiceDroite= fin+1;

		pasPlace = true;
		
        while (pasPlace)
        {   
        
			indiceGauche = indiceGauche + 1 ;
			while ( (indiceGauche<=fin) && (valeurPivot.precede(tab[indiceGauche]))==false && valeurPivot.estEgale(tab[indiceGauche])==false ){ 
				indiceGauche = indiceGauche + 1 ;
			}
			
			indiceDroite = indiceDroite - 1 ;
			while ( (valeurPivot.precede(tab[indiceDroite])) ){
				indiceDroite = indiceDroite - 1 ;
			}
			
			if (indiceGauche<=indiceDroite){
				echanger(indiceGauche,indiceDroite);
			}else{
				pasPlace = false;
			}
		}
		
		echanger(indicePivot,indiceDroite);
		return indiceDroite ;
    }
    
    private void triRapide(int debut, int fin)
    {	int indicePivot;
    	
        if (fin <= debut){
        	return ;		// entre debut et fin, il reste 0 ou 1 element : on a fini !
    	}
     
        indicePivot = placePivot(debut,fin);  	// pivotage du tableau 
        triRapide(debut, indicePivot-1) ;		// tri reccursif de la partie gauche de tab[debut-fin]
        triRapide(indicePivot+1, fin);			// tri reccursif de la partie droite de tab[debut-fin]
    }		
		
	public void triRapide()
	{
		triRapide(0,taille-1);
	}	
	
	
	
}	// fin de la classe VecteurEntier
